/* ------------------------------------------------------------------------
    nodes.c

    This code must be compiled (under dos anyway) in the Compact memory model.

    A Citadel utility to generate network message statistics.

    Written by Audin Malmin.

    With other code by various Citadel authors and Golden Spud.

    This code is Public Domain.  So do with it as you please.

    However, if you sell it then you will become very evil and I shall
    probably never speak to you again.

    There is, of course, no warranty what so ever.  This code works fine
    on my system and the few others it's been used on.  But if it makes
    your system melt down in front of your eyes then its your own fault.

    If you have questions or comments, I can be reached at:

    Magrathea @ Skaro, Olympia [skr.olm]  (CitNet)

    amalmin@halcyon.com  (Internet)

    or, if all else fails:

    Audin Malmin
    1317 Horne St. N.E.
    Olympia, WA 98516-5613

 --------------------------------------------------------------------------
 History:       (New entries go at the END...:-)

 ???????/ANM    Version 1.0
                Nodelist only.
                Userlist is a seperate program.
 ???????/ANM    Version 2.0
                Command line options
                Roomlist
                other improvements.
 ???????/ANM    Version 3.0
                Userlist incorporated.
                Extended nodelist
                don't over-write files.
                [And theres some other stuff here too...:-)]
                [^^ Pre-history.  vv Post-history.]
 95dec14/ANM    Played with GetStr().  Took runtime from 320sec to 280sec.
                Zapped a few feof calls in readmessage...time to 276 sec.
                Created usage().
                Decreased the number of deansi() calls...saved 3 seconds.wow
                Added Spud's hash stuff.  a user hash alone saves 47seconds.
                Using hashing on roomnames dropped the time to 195 seconds!
                So we've shaved 125 seconds off the time today, i'm impressed.
 95dec16/ANM    Stuck in a bunch of Golden Spud's linked-list code.  nice
    |           and fast.
    |           Fixed a bug in stripansi().  pain in the butt, that was.
    |           Added a stricmp check after the hash check...just because...
    |           Added sort stuff.  Thought there must be a better way...
 95dec18/ANM    Version up to 5.0.
 95dec19/ANM    Added config file stuff.
                Added multiple status displays...
                And added the exclusion code...although it's not ideal yet.
                Version 5.0 released.
 95dec25/ANM    Expanded config file options.  Got rid of the CLI stuff.
                Version 5.0a released.
 95dec26/ANM    And even more config file options...
                Version 5.1 released.
 95dec30/ANM    Added compressed message detection.
                Added compressed message handling...
                Added local message detection.  (excluded from list.)
                Number of Local messages are listed in nodes.lst file.
                Added attribute byte (1st and 2nd) handling and room number
                byte (1st and 2nd as well) handling...although its not used.
                Version 6.0.
 96jan02/ANM    Added network connections list.
 96jan03/ANM    Version 6.0 released.
 96jan06/ANM    STAMP program finished...and installed on Skaro.
 96jan08/ANM    Delay stuff started...  it works, but I don't yet know if its
                    correct...
                Added a formatting space to nodes.txt output. (as per DIETRA's
                    request.)
                Version up to 7.0.
 96jan14/ANM    Fixed a memory corruption bug in GetStr().
                Installed new stripansi().
                Closed a few un-needed streams.
                Number of stamped messages is tracked. (needed for delay list)
                More work on the delay stuff.  Working much better now.
                    It even looks nice.
                delayout();
                Report memory usage on exit.
                Mention that command line parameters are ignored.
                Startup status screen moved to startup() function.
                readMessage() no longer calls the stat functions.  They are
                    called by the main loop.
                Track local message volume.  (bytes)
                Removed the Jaydee exclusion stuff.  He no longer plays with
                    his nodename all the time...Although a Night Star
                    exclusion function might be nice... :-)
 96jan15/ANM    Totals in the Delay stuff...  global averages.
                Other delay processing cleanups...
                Ignore hidden comment fields. (those starting with '%')
                stamp();
                Display address in delay list if the nodename is too long.
                stamp() can handle the new stamp format.
                node.address from a label to a 9 character string.  The node
                    list was taking up over 20K memory on my machine. This'll
                    save a bit of ram.
                Now keeps track of the actual software string.  displayed in
                    the extended node list.  (node.longsoft)
                    (great...back to a 22k node structure...)
 96jan24/ANM    Fixed a screwy bug with comment strings.  (oops, type-o...)
                Something weird is going on with cLength.
 96jan25/ANM    msgbuf structure...
                Mail detection.
                cLength() stuff worked on.
                Message copy detection. (be nice if the docs mentioned these.)
                Lots of commenting.
                Part of the cLength problem is in Citadel itself.
                Fixed the other cLength problem.
 96jan26/ANM    Moved some stuff around.
                Zapped the rest of the jaydee stuff.
                region stuff.
 96fed02/ANM    zapped hashes from the region code.
                hop stuff.
 96feb04/ANM    configurable color stuff.
                global hop information works better.
                optimized hops() function.
 96feb05/ANM    Better configurable color.
                msgbuf.ldelay;
 96feb06/ANM    Faster bargraph.
 96feb11/ANM    headers()
                openoutfile()
                soft.lst
                softstat();
 96feb14/ANM    overwrite
                added new files to the status screen.
                Spuds bar graph stuff.
                start message size stuff.
                hashes back in the region code.
 96feb16/ANM    sort()
                usage in the software list.
                more work on msg size stuff.  it kind of works now. :)
 96feb17/ANM    msg size stuff expanded greatly.
                    configurable interval.
                    configurable graph character.
                    configurable graph type.
                    Works great.
                Exclusions.  Node, user, room, region, software...  (way
                    nifty exclusion code, too...:-)
                moved stripansi calls to readmessage(), so they only ever get
                    called once.
 96feb18/ANM    lower_end, upper_end.
                multiple.
                msgbuf.hash* stuff.  Cut about 10 seconds off the runtime.
 96feb19/ANM    list_type stuff.
                multiple to scale.
                scale = -1...
 96feb20/ANM    rewrote GetStr to use pointers...  hopefully it will be a bit
                    quicker.
                pointers in hash(), hops(), and played with stamp() a bit.
                Capture ctrl-break.
 96feb21/ANM    Hashes in address code.
 96mar03/ANM    Zapped all the floating point stuff.  shaved 15K off of the
                    exec size.  It's also very slightly faster.  The %msgb in
                    the nodelist is slightly inaccurate, but by never more
                    than 1%.  Everything else is almost unchanged.
                Updated the startup screen.
                Replaced the last few hard-coded ^A codes.
                final few cleanups.
                Version 7 released.
 -------------------------------------------------------------------------- */
#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  <dir.h>
#include  <dos.h>
#include  <io.h>
#include  <alloc.h>
#include  <time.h>
#include  <ctype.h>
#include  "../stat/pragmas.h"

#define   FALSE     0
#define   TRUE      1
#define   LABELSIZE 30
							/* these are message attributes. */
#define COMPRESSED  0x08    // Compressed message.
#define MORE        0x40    // message has a second attribute byte.
#define BIGROOM     0x20    // Message uses 16 bits for the room number
#define LOCAL       0x01    // (attr2) message is local-only.

#define CTRL_A      1
#define CTRL_B      2

#define BAR         0       // These are graph types.
#define SCATTER     1

#define XNODE       0       // these are params for the AddExcl function.
#define XUSER       1
#define XROOM       2
#define XREGION     3
#define XSOFT       4

typedef char label[LABELSIZE + 1];

FILE    *msgdat;
FILE    *nodesout,
        *roomsout,
        *usersout,
        *nodes2out,
        *linkslst,
        *delayout,
        *regionout,
        *softout,
        *sizeout;

#ifdef DEBUG
FILE    *debugout;
#endif

static  char version[]  = "7.0";

char    inputmail[257];
char    outputnode[257];
char    outputroom[257];
char    outputuser[257];
char    outputsoft[257];
char    outputdelay[257];
char    outputregion[257];
char    outlinklist[257];
char    outnodelist[257];
char    outsizelist[257];

#ifdef DEBUG
char	debugfile[257]	 = "debug.out";
#endif

static  int column       = 0;
const   int maxcol       = 78;

time_t  starttime, endtime;

long    mdatlength       = 0;   // Length of the message file.
int     overwrite        = 0;   // Overwrite files?

// Bar graph stuff.
static  char start_ch;
static  char fill_ch;
static  long screenlen;
static  long screencur;
static  long reallen;
static  long realcur;
char    fuelfull;       // Filled in fuelbar character...
char    fuelempty;      // Blank fuelbar.

// Config stuff.
label   homenode,
        homeadd,
        homealias,
        homesoft,
        homeregion,
        homestate,
        homecountry,
        homephone;
int	    exclusions = 0,
        use_color = 1,    // Color in output?
        debug     = 0,    // Debug mode?
        status    = 0,    // Type of status display at runtime. Ignored if debug = 1
        stepsize  = 200,  // size of message steps.
        lower_end = 0,    // lower end of graph.
        upper_end = 8192, // upper end.
        scale     = 1000, // controls the length of graph lines.
        graphtype = BAR;  // Message size graph type.
char    graphchar = '';  // character to use for the message size graph.

int     *msg_size;       // message sizes pointer...
int     totalsteps;      // total number of steps.

int     typenode = 0,    // these are set by the type_XXXX config settings.
        typeuser = 0,    // they control how many nodes, users, etc get listed.
        typeroom = 0,
        typesoft = 0,
        typelink = 0,
        typeregion = 0;

// Colors.
struct {
    label   norm,   // Normal text color.
            bright, // Highlighted text color.
            line,   // Color of lines.
            head,   // Color of headers.
            tail,   // Color of tails.
            comma;  // color of commas in extended nodelist.
} color;

// Message buffer.
struct {
	label 	soft, 				// Software field
			nodename,           // Nodename
			address,			// Address
			air,				// Region as airport code
			author,             // Author
			datestr,			// Datestamp.
			roomname,           // Room
			region,             // Region
			state,              // State
			country,            // Country
			phone,              // Phone
			mailto,             // Mail. ('T' field.)
			ID,                 // ID number, ASCII string.
			stamp;              // Time stamp, if one exists.
    int     softhash,           // several hundred different hashes... :-)
            nodehash,
            airhash,
            authorhash,
            roomhash,
            addhash;
	char    path[513],			// Path
			messagetext[8193],  // Message text.
			sig[81],			// Sig line (BBS Sig)
			comment[257];       // Last comment field, if there is one.
	unsigned char attr, attr2,	// Attribute bytes 1 and 2.
				  room1, room2;	// Room bytes 1 and 2.
	int		hops;				// Number of hops.
	long    lstamp,				// Time Stamp as a long.
			ldate,              // msgbuf.datestr as a long.
			ldelay;				// Delay time in seconds.
} msgbuf;

// These both contain the length of msgbuf.messagetext.
int	    messagebyte = 0;    // Use this one for STAT functions.
int     length      = 0;    // This one is used in the cLength stuff.

// These are message totals.
long    nmessages   = 0;    // Total public network messages.
long    local       = 0;    // Total public local messages.
long    mail        = 0;    // Total Mail messages, local and network.

// These are message byte totals.
long    messagek    = 0;    // Total public net message bytes
long    localmsgk   = 0;    // Total public local message bytes
long    mailmsgk    = 0;    // Total Mail message bytes. Local and Network.

// These are the total number of structure entries.
int	    numnode     = 0;    // Total number of node structures.
int	    numroom     = 0;    // Total number of room structures.
int	    numuser     = 0;    // Total number of user structures.
int     numlink     = 0;    // Total number of link structures.
int     numregion   = 0;    // Total number of region structures.
int     numsoft     = 0;    // Total number of software structures.

// The node structure.
typedef struct node {
    label   name,
            phone,
            region,
            state,
            country;
    char    address[10];
    int     hash,           // hash of the nodename.
            softhash,       // hash of software name.
            addhash;        // hash of the address.
    long    longest,		// largest delay
            shortest,		// shortest delay
            average,		// growing average delay.. (average/stamped).
            stamped;		// number of stamped messages.
    int     longhop,		// longest number of hops.
            shorthop;		// shortest number of hops.
    long    avehop,			// growing average hops.
            hopped,			// number of messages with hop info.
            messages;		// Total number of messages from this node.
    unsigned long msgk;		// Total message bytes from the node.
    struct node* next;
    } node;

node*   firstnode = NULL;
node*   currnode  = NULL;

// The room structure.
typedef struct	room {
    label roomname;
    int hash;           // Hash of the roomname.
    long messages;
    unsigned long msgk;
    struct room* next;
    } room;

room* firstroom = NULL;
room* currroom  = NULL;

// The user structure.
typedef struct	user {
    label username;
    int	hash;			// Hash of the username
    long messages;
    unsigned long msgk;
    struct user* next;
    } user;

user*	firstuser = NULL;
user*	curruser  = NULL;

// Link structure.
typedef struct link {
	label add1;         // Address 1
	label add2;         // Address 2
	int hash1;          // Hash of 1
	int hash2;          // Hash of 2
	unsigned long messages;
	unsigned long msgk;
	struct link* next;
} link;

link*	firstlink = NULL;
link*	currlink = NULL;

// Region structure.
typedef struct region {
	label	name;
    int     hash;
	unsigned long messages;
	unsigned long msgk;
	struct region* next;
} region;

region*	firstregion = NULL;
region*	currregion = NULL;

typedef struct soft {
    label name;
    int   hash;
    unsigned long messages;
    unsigned long msgk;
    struct soft* next;
} soft;

soft*	firstsoft = NULL;
soft*	currsoft  = NULL;

typedef struct xclude {
    int  hash;
    struct xclude* next;
} xclude;

xclude* firstxuser   = NULL;
xclude* currxuser    = NULL;
xclude* firstxnode   = NULL;
xclude* currxnode    = NULL;
xclude* firstxroom   = NULL;
xclude* currxroom    = NULL;
xclude* firstxregion = NULL;
xclude* currxregion  = NULL;
xclude* firstxsoft   = NULL;
xclude* currxsoft    = NULL;

static	char *software[] = {
	"Autoposter",				/* 0 */
	"Gremlin's Citadel/064.2",	/* 1 */
	"Gremlin's Citadel/064",	/* 2 */
	"Gremlin's Citadel",		/* 3 */
    "Citadel+/Win32/",			/* 3a */
	"Citadel+/066",			/* 4 */
	"Citadel+/066",				/* 5 */
	"Citadel+/065",				/* 6 */
	"Citadel+",					/* 7 */
	"MavenCit",					/* 8 */
	"Co-Op Citadel",			/* 9 */
	"Frog's Citadel",			/* 10 */
	"Poster",					/* 11 */
	NULL
	};

static	char *softkey[] = {
	"APost",					/* 0  */
	"G/642",					/* 1  */
	"G/064",					/* 2  */
	"GCit",						/* 3  */
    "C+W32",					/* 3a */
	"+/66",					/* 4  */
	"C+/66",					/* 5  */
	"C+/65",					/* 6  */
	"Cit+",						/* 7  */
	"Mcit",						/* 8  */
	"Co-Op",					/* 9  */
	"Frog",						/* 10 */
	"Postr",					/* 11 */
    NULL
	};

int   main(int argc, char *argv[]);
void  startup(void);
int   readMessage(void);
void  nodestat(void);
void  roomstat(void);
void  userstat(void);
void  pathstat(void);
void  linkstat(label alias1, label alias2);
void  regionstat(void);
int	  stampstat(void);
int	  softstat(int mode);
void  msgstat(void);
int   GetStr(FILE *fil, char *str, int mlen);
int   LenStr(FILE *fil);
int   cLength(void);
void  error(void);
int   hops(void);
int   isaddress(const char *str);
int   exclude(void);
void  AddExcl(int type, char *string);
/* could someone who understands this fix it so it isn't so redundant? */
/***********************************************************************/
int   Nsort(node* this, node* that);
node* Nlmerge(node* p, node* q);
node* Nlsort (node* p);
int	  Usort(user* this, user* that);
user* Ulmerge(user* p, user* q);
user* Ulsort (user* p);
int	  Rsort(room* this, room* that);
room* Rlmerge(room* p, room* q);
room* Rlsort (room* p);
int	  Gsort(region* this, region* that);
region* Glmerge(region* p, region* q);
region* Glsort (region* p);
int	  Ssort(soft* this, soft* that);
soft* Slmerge(soft* p, soft* q);
soft* Slsort (soft* p);
int	  Lsort(link* this, link* that);
link* Llmerge(link* p, link* q);
link* Llsort (link* p);
/************************************************************************/
void  output(void);
void  outdelay(void);
int   criteria(long msgk, int listtype, int i);
int	  hash(const char* s);
void  stripansi(char *str);
void  expand(char *str);
void  usage(void);
void  config(char softname[257]);
void  headers(void);
void  o_reset(char s, char f, long sl, long rl);
void  o_update(long rl);
void  sort(void);
FILE  *openoutfile(char* name);
FILE  *pfopen(const char* name, const char* mode, const char* dirs);
int   cbreak(void);

/****************************************************************************/
/* main() -- Look Golden Spud!  it returns an int! :-)                      */
/****************************************************************************/
int main(int argc, char *argv[])
{
clock_t ticks;
int     good = 1;

    printf("\n"
           "Nodelist %s (%s %s)\n"
           "\n"
           "By Magrathea, Golden Spud, and Mystery Man\n"
           "\n"
           "With other code by Brent Bottles and various other Citadel authors.\n"
           "\n" , version, __DATE__, __TIME__);

    if(argc > 1)
        printf("Hmm... You've given me a command line option...I don't understand any"
               " of those.  So stick your options in the config file instead.\n\n");

    homenode[0]    = 0;
    homeadd[0]     = 0;
    homealias[0]   = 0;
    homeregion[0]  = 0;
    homestate[0]   = 0;
    homecountry[0] = 0;
    homephone[0]   = 0;
    homesoft[0]    = 0;

    strcpy(inputmail, "c:\\cit\\messages\\msg.dat");
    strcpy(outputnode, "nodes.lst");
    strcpy(outputroom, "rooms.lst");
    strcpy(outputuser, "users.lst");
    strcpy(outputsoft, "soft.lst");
    strcpy(outputdelay, "delay.lst");
    strcpy(outputregion, "region.lst");
    strcpy(outlinklist, "links.lst");
    strcpy(outnodelist, "nodes.txt");
    strcpy(outsizelist, "msg_size.lst");

    strcpy(color.norm, "0");
    strcpy(color.line, "3a");
    strcpy(color.bright, "3");
    strcpy(color.head, "e");
    strcpy(color.tail, "");
    strcpy(color.comma, "");

    fuelempty   = '';
    fuelfull    = '';

    config(strlwr(argv[0]));
    startup();
    headers();

    // Main loop...
    while(good)
    {
        good = readMessage();

        if(good == 1 && msgbuf.nodename[0])
        {
            nmessages++;
            messagek += messagebyte;
            nodestat();
            roomstat();
            userstat();
            pathstat();

            if(msgbuf.air[0])
                regionstat();

            msgstat();
            softstat(1);
        }
    }

	if(status != 3)
	{
		fflush(stdout);
		setvbuf(stdout, NULL, _IONBF, 8);
	}

	if(status == 3)
        o_update(ftell(msgdat));

    printf("\n\n"
           "Object  :size * num = total memory..\n"
           "\n");
	printf("Nodes   : %03u * %03d = %ld bytes...\n", sizeof(struct node),
			numnode, (long)(sizeof(struct node) * numnode));
	printf("Rooms   : %03u * %03d = %ld bytes...\n", sizeof(struct room),
			numroom, (long)(sizeof(struct room) * numroom));
	printf("Users   : %03u * %03d = %ld bytes...\n", sizeof(struct user),
			numuser, (long)(sizeof(struct user) * numuser));
	printf("Links   : %03u * %03d = %ld bytes...\n", sizeof(struct link),
			numlink, (long)(sizeof(struct link) * numlink));
	printf("Regions : %03u * %03d = %ld bytes...\n", sizeof(struct region),
			numregion, (long)(sizeof(struct region) * numregion));
    printf("Software: %03u * %03d = %ld bytes...\n", sizeof(struct soft),
            numsoft, (long)(sizeof(struct soft) * numsoft));

    sort();
    output();
    fcloseall();

    ticks = clock();
	printf("Elapsed time about %d seconds.\n", (int)ticks/(int)CLK_TCK);
    return(0);
}

/*
 * Read a message...
 */
int readMessage(void)
{
int     c, c2;
char    commtmp[257];
char    addtemp[513];
char    *bang = NULL;
label   copy;

    // reset the message buffer.

    copy[0]               = 0;
    messagebyte           = 0;
    addtemp[0]            = 0;
    commtmp[0]            = 0;
    msgbuf.ID[0]          = 0;
    msgbuf.nodename[0]    = 0;
    msgbuf.sig[0]         = 0;
    msgbuf.path[0]        = 0;
    msgbuf.address[0]     = 0;
    msgbuf.soft[0]        = 0;
    msgbuf.datestr[0]     = 0;
    msgbuf.mailto[0]      = 0;
    msgbuf.roomname[0]    = 0;
    msgbuf.author[0]      = 0;
    msgbuf.region[0]      = 0;
    msgbuf.state[0]       = 0;
    msgbuf.phone[0]       = 0;
    msgbuf.country[0]     = 0;
    msgbuf.messagetext[0] = 0;
    msgbuf.attr           = 0;
    msgbuf.attr2          = 0;
    msgbuf.room1          = 0;
    msgbuf.room2          = 0;
    msgbuf.ldate          = 0;
    msgbuf.lstamp         = 0;
    msgbuf.ldelay         = 0;

    /* find start of message */
    do {
       c = fgetc(msgdat);
    } while (c != 0xFF && c != EOF);

    if (c == EOF)
        return 0;

    msgbuf.attr = fgetc(msgdat);        // Get the first attribute byte.

    if((msgbuf.attr & MORE) != 0)       // Get second attribute byte, if there is one.
        msgbuf.attr2 = fgetc(msgdat);

    if((msgbuf.attr & BIGROOM) != 0)    // room is number 255 or greater, thus there
    {                                   // is 16 bits of room number.
        msgbuf.room1 = fgetc(msgdat);
        msgbuf.room2 = fgetc(msgdat);
    }
    else                                // room is number 254 or less, so theres only
        msgbuf.room1 = fgetc(msgdat);   // 8 bits of room number.

    (void)GetStr(msgdat, msgbuf.ID, 30);// Get the ID number.

    do {
        c = fgetc(msgdat);

        switch (c)
        {
            case 'A':   (void)GetStr(msgdat, msgbuf.author,   30);  break;
            case 'C':   (void)GetStr(msgdat, copy,            30);  break;
            case 'D':   (void)GetStr(msgdat, msgbuf.datestr,  30);  break;
            case 'R':   (void)GetStr(msgdat, msgbuf.roomname, 30);  break;
            case 's':   (void)GetStr(msgdat, msgbuf.soft,     30);  break;
            case 'T':   (void)GetStr(msgdat, msgbuf.mailto,   30);  break;
            case 'P':   (void)GetStr(msgdat, msgbuf.path,     256); break;
            case 'O':   (void)GetStr(msgdat, msgbuf.nodename, 30);  break;
            case 'o':   (void)GetStr(msgdat, msgbuf.region,   30);  break;
            case 'Q':   (void)GetStr(msgdat, msgbuf.state,    30);  break;
            case 'U':   (void)GetStr(msgdat, msgbuf.country,  30);  break;
            case 'H':   (void)GetStr(msgdat, msgbuf.phone,    30);  break;
            case '.':   (void)GetStr(msgdat, msgbuf.sig,      80);  break;
            case '_':   messagebyte += LenStr(msgdat);              break;
            case 'n':   messagebyte += LenStr(msgdat);              break;
            case 'N':   messagebyte += LenStr(msgdat);              break;
            case 'M':                                               break;
            case '%':
                GetStr(msgdat, msgbuf.comment, 256);
                if(msgbuf.comment[0] == '%')	// It's a hidden comment...
                    stampstat();
                else
                    messagebyte += strlen(msgbuf.comment);
                break;

            default:
                do {
                    c2 = fgetc(msgdat);
                } while(c2 && c2 !=EOF);
                break;
        }
    } while (c != 'M' && c != EOF);

    if (c == EOF)
        return 0;

    length = GetStr(msgdat, msgbuf.messagetext, 8192);

    if(msgbuf.mailto[0])
    {
        if(!status)
            fputc('M', stdout);
        return 2;
    }

    if(copy[0])
    {
        if(!status)
            fputc('C', stdout);
        return 2;
    }

	if((msgbuf.attr & COMPRESSED) != 0)	// is the message compressed?
		messagebyte += cLength();	// Yes...send it through cLength.
	else
		messagebyte += length;		// No...

	if((msgbuf.attr2 & LOCAL) != 0)  // it's a local message, skip it.
	{
		local++;
		localmsgk += messagebyte;
		if(!status)
			fputc('L', stdout);
		return 2;
	}

    if(!msgbuf.nodename[0] && msgbuf.sig[0]) // Message comes from the local node.
	{                                        // So we have to give it network fields.
		strcpy(msgbuf.nodename, homenode);
		strcpy(msgbuf.path, homeadd+1);
		strcpy(msgbuf.soft, homesoft);
		strcpy(msgbuf.region, homeregion);
		strcpy(msgbuf.state, homestate);
		strcpy(msgbuf.country, homecountry);
		strcpy(msgbuf.phone, homephone);
	}

  	if(strchr(msgbuf.nodename, CTRL_A))
        stripansi(msgbuf.nodename);
  	if(strchr(msgbuf.author, CTRL_A))
        stripansi(msgbuf.author);
    if(strchr(msgbuf.roomname, CTRL_A))
        stripansi(msgbuf.roomname);

	strcpy(addtemp, msgbuf.path);

	if((bang = strchr(addtemp, '!')) != NULL)
		*bang = 0;

	if(isaddress(addtemp))
	{
		strcpy(msgbuf.address, addtemp);
		if((bang = strchr(addtemp, '.')) != NULL)
			strcpy(msgbuf.air, bang+1);
		else
			msgbuf.air[0] = 0;
	}

    msgbuf.softhash   = hash(msgbuf.soft);
    msgbuf.nodehash   = hash(msgbuf.nodename);
    msgbuf.airhash    = hash(msgbuf.air);
    msgbuf.authorhash = hash(msgbuf.author);
    msgbuf.roomhash   = hash(msgbuf.roomname);
    msgbuf.addhash    = hash(msgbuf.address);

	msgbuf.hops = hops();   // set the hops.

    if(exclusions && exclude())
        return(2);

	return 1;
}

/*******************************************************/
/* nodestat() -- records node statistical information. */
/*******************************************************/
void nodestat(void)
{
int nodenum, lpc;
node* lp;
node* newnode;

	for (lpc = 0, lp = firstnode, nodenum = -1; lpc < numnode; ++lpc, lp = lp->next)
		if(msgbuf.nodehash == lp->hash)
			if(stricmp(msgbuf.nodename, lp->name) == 0) {
				nodenum = lpc;
				break;
				}

	if (nodenum==-1)	// New node...create an entry for it.
	{
		numnode++;
		nodenum=numnode-1;

		if(firstnode == NULL) {
			/* no current nodes. */
			firstnode = currnode = (node *)farmalloc(sizeof(node));
			currnode->next = NULL;
			}
		else {
			/* list has at least one entry. */
			newnode = (node *)farmalloc(sizeof(node));
			newnode->next = NULL;
			currnode->next = newnode;
			currnode = newnode;
			}

        strcpy(currnode->name, msgbuf.nodename);
        strcpy(currnode->address,  msgbuf.address);
        strcpy(currnode->region,   msgbuf.region);
        strcpy(currnode->state,    msgbuf.state);
        strcpy(currnode->country,  msgbuf.country);
        strcpy(currnode->phone,    msgbuf.phone);

        currnode->softhash   = softstat(0);
        currnode->hash       = msgbuf.nodehash;
        currnode->addhash    = msgbuf.addhash;
        currnode->messages   = 1;
        currnode->msgk       = messagebyte;

        if(msgbuf.ldelay) {
            currnode->average   = msgbuf.ldelay;
            currnode->longest   = msgbuf.ldelay;
            currnode->shortest  = msgbuf.ldelay;
            currnode->stamped   = 1;
        }
        else {
            currnode->average   = 0L;
            currnode->shortest  = 0L;
            currnode->longest   = 0L;
            currnode->stamped   = 0;
        }

        if(msgbuf.hops) {
            currnode->avehop	= msgbuf.hops;
            currnode->longhop	= msgbuf.hops;
            currnode->shorthop	= msgbuf.hops;
            currnode->hopped	= 1;
        } else
        {
            currnode->avehop	= 0;
            currnode->longhop	= 0;
            currnode->shorthop	= -1;
            currnode->hopped	= 0;
        }

        if(status == 3)
            o_update(ftell(msgdat));

        if(debug)
            printf("new node: [%30s] (%7s), %s\n",
                   msgbuf.nodename, msgbuf.address, msgbuf.soft);
        else {
             if(!status)
                 fputc('', stdout);
             else
                 if (status == 1) {
                     printf("\rNode:%3d. %-30s", numnode, msgbuf.nodename);
                 } else if (status == 2) {
                     if (column + 33 > maxcol) {
                         printf("\n");
                         column = 0;
                         }
                     column += printf("N:%-30s  ", msgbuf.nodename);
                 }
        }
    } else
    {     		// old node. update it's entry.
        lp->messages++;
        lp->msgk += messagebyte;

        if(msgbuf.address[0] && lp->addhash != msgbuf.addhash)
        {
			if(debug)
				printf(" address: [%30s] %s to %s\n",
						msgbuf.nodename, lp->address, msgbuf.address);

			strcpy(lp->address, msgbuf.address);
            lp->addhash = msgbuf.addhash;
		}

        if(msgbuf.soft[0] && lp->softhash != msgbuf.softhash)
        {
			lp->softhash = softstat(0);
        }

		if(msgbuf.ldelay)
		{
			lp->average += msgbuf.ldelay;
			lp->stamped++;

			if(!lp->longest)
				lp->longest = msgbuf.ldelay;
			else
				if(msgbuf.ldelay > lp->longest)
					lp->longest = msgbuf.ldelay;

			if(!lp->shortest)
				lp->shortest = msgbuf.ldelay;
			else
				if(msgbuf.ldelay < lp->shortest)
					lp->shortest = msgbuf.ldelay;
		}

    	if(msgbuf.hops) {
			lp->avehop += msgbuf.hops;
			lp->hopped++;

			if(!lp->longhop)
				lp->longhop	= msgbuf.hops;
			else
				if(msgbuf.hops > lp->longhop)
					lp->longhop = msgbuf.hops;

			if(lp->shorthop == -1)
				lp->shorthop = msgbuf.hops;
			else
				if(msgbuf.hops < lp->shorthop)
					lp->shorthop = msgbuf.hops;
		}
	}
}

/******************************************************/
/* roomstat() -- records room statistical information */
/******************************************************/
void roomstat(void)
{
int roomnum, lpc;
room* lp;
room* newroom;

	for(lpc = 0, lp = firstroom, roomnum = -1; lpc < numroom; ++lpc, lp = lp->next)
		if(msgbuf.roomhash == lp->hash)
			if(stricmp(msgbuf.roomname, lp->roomname) == 0) {
				roomnum = lpc;
				break;
				}

	if (roomnum==-1)
	{
		numroom++;
		roomnum=numroom-1;

		if(firstroom == NULL) {
			/* no elements at the moment. */
			firstroom = currroom = (room *)farmalloc(sizeof(room));
			currroom->next = NULL;
		} else {
			/* list has one or more elements */
			newroom = (room *)farmalloc(sizeof(room));
			newroom->next = NULL;
			currroom->next = newroom;
			currroom = newroom;
		}

		strcpy(currroom->roomname, msgbuf.roomname);
		currroom->hash = msgbuf.roomhash;
		currroom->msgk = messagebyte;
		currroom->messages = 1;

		if(debug)
			printf("New Room: {%30s}\n", msgbuf.roomname);
		else
			if(!status)
				fputc('', stdout);
			else {
				if (status == 1) {
					printf("\rRoom:%3d. %-30s", numroom, msgbuf.roomname);
				} else if (status == 2) {
					if (column + 33 > maxcol) {
						printf("\n");
						column = 0;
						}
					column += printf("R:%-30s  ", msgbuf.roomname);
					}
			}
	} else {
		lp->msgk += messagebyte;
		lp->messages++;
	}
}

/************************************************************************/
/* userstat() -- records user info.                                     */
/************************************************************************/
void userstat(void)
{
int usernum, lpc;
user* lp;
user* newuser;

	for (lpc=0, lp = firstuser, usernum=-1; lpc < numuser; ++lpc, lp = lp->next)
		if(msgbuf.authorhash == lp->hash && stricmp(msgbuf.author, lp->username)==0)
		{
			usernum=lpc;
			break;
		}

	if (usernum==-1)
	{
		numuser++;
		usernum=numuser-1;

		if(firstuser == NULL) {
			/* no current elements. */
			firstuser = curruser = (user *)farmalloc(sizeof(user));
			curruser->next = NULL;
		}
		else {
			/* at least one element exists. */
			newuser = (user *)farmalloc(sizeof(user));
			newuser->next = NULL;
			curruser->next = newuser;
			curruser = newuser;
		}
		strcpy(curruser->username, msgbuf.author);
		curruser->hash = msgbuf.authorhash;
		curruser->messages = 1;
		curruser->msgk = messagebyte;

		if(debug)
			printf("new user: [%25s]\n", msgbuf.author);
		else
		{
			if(status == 0)
				fputc('', stdout);
			else
				if (status == 1) {
					printf("\rUser:%3d. %-30s", numuser, msgbuf.author);
				} else if (status == 2) {
					if (column + 33 > maxcol) {
						printf("\n");
						column = 0;
					}
					column += printf("U:%-30s  ", msgbuf.author);
				}
			}
	}
	else
	{
		lp->messages++;
		lp->msgk += messagebyte;
	}
}

/************************************************************************/
/* regionstat() -- records region info.                                 */
/************************************************************************/
void regionstat(void)
{
int regionnum, lpc;
region* lp;
region* newregion;

	for (lpc=0, lp = firstregion, regionnum=-1; lpc < numregion; ++lpc, lp = lp->next)
        if(msgbuf.airhash == lp->hash)
		{
			regionnum=lpc;
			break;
		}

	if (regionnum==-1)
	{
		numregion++;
		regionnum=numregion-1;

		if(firstregion == NULL) {
			/* no current elements. */
			firstregion = currregion = (region *)farmalloc(sizeof(region));
			currregion->next = NULL;
		}
		else {
			/* at least one element exists. */
			newregion = (region *)farmalloc(sizeof(region));
			newregion->next = NULL;
			currregion->next = newregion;
			currregion = newregion;
		}

		strcpy(currregion->name, msgbuf.air);
        currregion->hash = msgbuf.airhash;
		currregion->messages = 1;
		currregion->msgk = messagebyte;

		if(debug)
			printf("new rgon: [%25s]\n", msgbuf.air);
		else
		{
			if(status == 0)
				fputc('r', stdout);
			else
				if (status == 1) {
					printf("\rRgon:%3d. %-30s", numregion, msgbuf.air);
				} else if (status == 2) {
					if (column + 33 > maxcol) {
						printf("\n");
						column = 0;
					}
					column += printf("G:%-30s  ", msgbuf.air);
				}
			}
	}
	else
	{
		lp->messages++;
		lp->msgk += messagebyte;
	}
}

/***************************************************************************/
/* pathstat() - keeps tabs on network connections...                       */
/* ----------------------------------------------------------------------- */
/* I really don't like this function...  I find it quite ugly...           */
/* I'd be delighted if someone could come up with a nicer one...           */
/* I also think it's going to rival userstat() as the most time-intensive  */
/* part of this program...i'll have to profile it again and find out...    */
/***************************************************************************/
void pathstat(void)
{
char    wpath[513];
char    *ptr;			// pointer to start of current part of path
char    *end;			// pointer to ending bang.
char    *point;         // pointer to period in address.
char    add1[31];       // address 1
char    add2[31];		// address 2
char    air[31];		// current airport code.
char    *good;			// and this is a hack.

    strcpy(wpath, msgbuf.path);
    strcat(wpath, homeadd);

    ptr = wpath;

    if(strchr(ptr, '!'))
		do {
			end = NULL;
			good = end = strchr(ptr, '!');
			if(end)
				*end = 0;
            else
                printf("\npath: no end");

			if((point = strchr(ptr, '.')) != NULL)
				strcpy(air, point);

			strcpy(add1, ptr);
			if(!strchr(add1, '.') && strlen(add1) <= 4 && add1[0])
				strcat(add1, air);
			if(end)
				*end = '!';
            else
                printf("\npath2: no end");

			good = ptr = end+1;
			end = NULL;

			good = end = strchr(ptr, '!');
			if(end)
				*end = 0;

			strcpy(add2, ptr);
			if(!strchr(add2, '.') && strlen(add2) <= 4 && add2[0])
				strcat(add2, air);
			if(end)
				*end = '!';

			if(add1[0] && add2[0] && isaddress(add1) && isaddress(add2) && stricmp(add1, add2))
				linkstat(add1, add2);
		} while(good);
}

/************************************************************************/
/* linkstat() - this is used by pathstat.                               */
/************************************************************************/
void linkstat(label alias1, label alias2)
{
int linknum, lpc, h1, h2;
link* lp;
link* newlink;

	h1 = hash(alias1);
	h2 = hash(alias2);

	for (lpc=0, lp = firstlink, linknum=-1; lpc < numlink; ++lpc, lp = lp->next)
		if((h1 == lp->hash1 && h2 == lp->hash2) ||
		   (h1 == lp->hash2 && h2 == lp->hash1))
		{
			linknum=lpc;
			break;
		}

	if (linknum==-1)
	{
		numlink++;
		linknum=numlink-1;

		if(firstlink == NULL) {
			/* no current elements. */
			firstlink = currlink = (link *)farmalloc(sizeof(link));
			currlink->next = NULL;
			}
		else {
			/* at least one element exists. */
			newlink = (link *)farmalloc(sizeof(link));
			newlink->next = NULL;
			currlink->next = newlink;
			currlink = newlink;
			}

		strcpy(currlink->add1, alias1);
		strcpy(currlink->add2, alias2);
		currlink->hash1 = h1;
		currlink->hash2 = h2;
		currlink->messages = 1;
		currlink->msgk = messagebyte;

		if(debug)
			printf("new link: <%s!%s>\n", currlink->add1, currlink->add2);
		else
		{
			if(status == 0)
				fputc('!', stdout);
			else
				if (status == 1) {
					printf("\rlink:%3d. %-15s!%-14s", numlink, alias1, alias2);
				} else if (status == 2) {
					if (column + 33 > maxcol) {
						printf("\n");
						column = 0;
					}
					column += printf("L:%-15s!%-14  ", alias1, alias2);
				}
		}
	}
	else
	{
		lp->messages++;
		lp->msgk += messagebyte;
	}
}
/************************************************************************/
/* stamp() -- sets msgbuf.lstamp and msgbuf.ldelay                      */
/************************************************************************/
int     stampstat(void)
{
char    *ptr = NULL;
char    *comma = NULL;

	if(msgbuf.datestr[0])
		msgbuf.ldate = atol(msgbuf.datestr);
	else
		return 0;

    if(!strncmpi(msgbuf.comment+1, homeadd+1, strlen(homeadd+1)))
    {
        ptr = msgbuf.comment + strlen(homeadd) + 2;

        if((comma = strchr(ptr, ',')) != NULL)
			*comma = 0;
		else
        {
            printf("\nstamp: no comma");
        }

        msgbuf.lstamp = atol(ptr);

		if(msgbuf.lstamp < msgbuf.ldate)
			msgbuf.lstamp = 0;
		else
			msgbuf.ldelay = msgbuf.lstamp - msgbuf.ldate;
	}
	return(0);
}

/**************************************************************************/
/* msgstat() -- Records info for the msg size graph.                      */
/**************************************************************************/
void msgstat(void)
{
int i, index;

    for(i = lower_end, index = 0; index < totalsteps; i += stepsize)
    {
        if(messagebyte >= i && messagebyte < i + stepsize)
        {
            msg_size[index]++;
            break;
        }
        else
            index++;
    }
}

/************************************************************************/
/* softstat()                                                           */
/************************************************************************/
int softstat(int mode)
{
int softnum, lpc;
soft* lp;
soft* newsoft;

    for (lpc = 0, lp = firstsoft, softnum = -1; lpc < numsoft; ++lpc, lp = lp->next)
        if(msgbuf.softhash == lp->hash)
        {
            softnum = lpc;
            break;
        }

    if (softnum==-1)	// New software...create an entry for it.
    {
        numsoft++;
        softnum=numsoft-1;

        if(firstsoft == NULL) {
            /* no current nodes. */
            firstsoft = currsoft = (soft *)farmalloc(sizeof(soft));
			currsoft->next = NULL;
		}
		else {
			/* list has at least one entry. */
			newsoft = (soft *)farmalloc(sizeof(soft));
			newsoft->next = NULL;
			currsoft->next = newsoft;
			currsoft = newsoft;
		}

        strcpy(currsoft->name, msgbuf.soft);
        currsoft->hash = msgbuf.softhash;
        currsoft->messages = 1;
        currsoft->msgk = messagebyte;

        if(debug)
            printf("\nNew software: %s", msgbuf.soft);
    } else
    {
        if(mode == 1)
        {
            lp->messages++;
            lp->msgk += messagebyte;
        }
    }
    return(msgbuf.softhash);
}

/************************************************************************/
/* hops()																*/
/************************************************************************/
int    hops(void)
{
char   *ptr;
int    numhops = 1;

    if(!msgbuf.path[0] || strstr(msgbuf.path, ".."))
        return 0;

    for(ptr = msgbuf.path; *ptr != 0; ptr++)
        if(*ptr == '!')
            numhops++;

    return(numhops);
}

/* -------------------------------------------------------------------- */
/*  isaddress() examines string and returns true if it looks like an    */
/*              alias (xxx.xxxx)                                        */
/* --------------------------------------------------------------------
    94Sep26 22:48:28 From Brent Bottles @ The Anticlimactic Teleservice, 
Seattle In WAN Admin>
"St. Dism" continues to be less than valid as an address.				*/

int isaddress(const char *str)
{
int len;
int dotpos;
int FoundDot = FALSE;
int i;

	len = strlen(str);

	// Don't be fooled by "St. Dism"
	if (strchr(str, ' ') != NULL)
		{
		return (FALSE);
		}

	for (i = 0; i < len; i++)
		{
		if (str[i] == '.')
			{
			// we can only have one dot.
			if (FoundDot)
				{
				return (FALSE);
				}

			dotpos = i;
			FoundDot = TRUE;
			}
		}

	if  (   // 1, 2, or 3 chars, no dots
			((len > 1) && (len < 4) && !FoundDot)

			||

			// 4, 5, 6, 7, or 8 chars, there is a dot, and it is at char
			// pos 2, 3, or 4, and not too close to the end.
			(   (len > 3) && (len < 9) && FoundDot && (dotpos > 1) &&
				(dotpos < 4) && ((len - dotpos) < 6)
			)
		)
		{
		return (TRUE);
		}

	return (FALSE);
}

/*  
 (That 'Don't be fooled by "St. Dism"' comment is a little out-of-date: 
checking for the position of the dot was added later, and "St. Dism" would fail
that.  However, this check is still good to do, as "poo.po o" would pass the 
dotpos test, but fail the strchr() test.) 

------
i'm cute
*/

/* -------------------------------------------------------------------- */
/*  GetStr()        gets a null-terminated string from a file           */
/* -------------------------------------------------------------------- */
int GetStr(FILE *fil, char *str, int mlen)
{
int  ch = 1;
char *ptr, *end;

    end = ptr = str;
    end += mlen;

    while(ch != EOF && ch)
    {
		ch=getc(fil);
        if(ptr < end)
		{
            *ptr = ch;
            ptr++;
		}
	}
    *ptr = 0;
    return((int)(ptr - str));
}

/* -------------------------------------------------------------------- */
/*  LenStr()        Same as GetStr, but this just dumps the input.      */
/*  This is, of course, another attempt at optimization..doesn't really */
/*  help, though.                                                       */
/* -------------------------------------------------------------------- */
int LenStr(FILE *fil)
{
	int   l = 0;
	int  ch;

	do {
		ch=fgetc(fil);
		l++;
	} while(ch && ch != EOF);
	return(l);
}

/* -------------------------------------------------------------------- */
/*  hash()          Make an int out of their name                       */
/* -------------------------------------------------------------------- */
int hash(const char* s)
{
int h = 0;
int shift;
const char *ptr;

    for (h=shift=0, ptr = s; *ptr; shift=(shift+1)&7, ptr++)
	{
        h ^= (toupper(*ptr)) << shift;
	}
	return h;
}

// changes string being sent, does not return a pointer like deansi
void stripansi(char *str)
    {
    char *pc, *i;
 
    i = pc = str;
 
    while (*pc)
        {
        if (*pc == CTRL_A || *pc == CTRL_B)
            {
            if (*(pc + 1))
                {
                pc += 2;
 
                if (toupper(*(pc - 1)) == 'X')
                    {
                    while (*pc > CTRL_B && !isspace(*pc) &&
                            toupper(*pc) != 'X' && *pc != '\r' && *pc != '\n')
                        {
                        pc++;
                        }
 
                    if (toupper(*pc) == 'X')
                        {
                        pc++;
                        }
                    }
                }
            else
                {
                pc++;
                }
            }
        else
            {
            *i = *pc;
            i++;
            pc++;
            }
        }
    *i = 0;
	}

/****************************************************************************/
/* cLength() - returns the uncompressed size of a message in bytes.         */
/****************************************************************************/
int cLength(void)
{
unsigned char comp_type; // compression type
unsigned char lsb, msb, b;
unsigned short uc_msglen; // uncompressed message length
int i=0;

	comp_type = msgbuf.messagetext[i];
	i++;

	if(comp_type != 0x01)	// Compression isn't of type 1!  We don't know how
	{
	if(!status)
		fputc('*', stdout);

#ifdef DEBUGCOMP
char	tempattr[21];
char    tempattr2[21];
char    temproom1[21];
char    temproom2[21];

		itoa((int)msgbuf.attr, tempattr, 2);
		itoa((int)msgbuf.attr2, tempattr2, 2);
		itoa((int)msgbuf.room1, temproom1, 2);
		itoa((int)msgbuf.room2, temproom2, 2);
		printf("\nwoW: %s, %d\n%s", tempattr, length, msgbuf.messagetext);
		if((msgbuf.attr & COMPRESSED) != 0)
			printf("\nMessage was marked compressed.");

		if((msgbuf.attr2 & LOCAL) != 0)
			printf("\nMessage was marked local.");

		printf("\n%s, %s, %s, %s",msgbuf.ID, msgbuf.roomname, msgbuf.author, msgbuf.nodename);
        printf("\n%s, %08s,%08s,%08s,%08s\n", outnodelist, tempattr, tempattr2, temproom1, temproom2);
		putc('\n', stdout);
#endif
		return length;	// to handle that...so....
	}

	lsb = msgbuf.messagetext[i];
	i++;

	if (lsb == 0x1b)
	{
		b = msgbuf.messagetext[i];
		i++;

		if(b == 0x01)
			lsb = 0x00;
		else
			if(b == 0x02)
				lsb = 0x1b;
			else
				if(b == 0x03)
					lsb = 0xff;
				else
				{
					printf("\nProblem with cLength(lsb)\n%s\n", msgbuf.messagetext);
					return 0;
				}
	}

	// this code gets past the <= 65.155 MSB bug
	msb = msgbuf.messagetext[i];
	i++;

	if (msb == 0x1b)
	{
		b = msgbuf.messagetext[i];
		i++;

		if (b == 0x01)
			if (length < 300)
				msb = 0x00;
			else
				msb = 0x1b;
			else
				if (b == 0x02)
					msb = 0x1b;
				else
					if(b == 0x03)
						msb = 0xff;
					else
					{
						printf("\nProblem with cLength(msb)\n%s\n", msgbuf.messagetext);
						return 0;
					}
	}
	uc_msglen = lsb | (msb << 8);

	if(uc_msglen < 0)
	{
        printf("Grumble, cLength is broken again: %u\n", uc_msglen);
        return length;
	}

	return uc_msglen;
}

/****************************************************************************/
/* sorting stuff...which I don't really understand...                       */
/****************************************************************************/
int Nsort(node* this, node* that) {
	if (strcmp(this->name,that->name) < 0)
		return -1;
	else
		if (strcmp(this->name,that->name) > 0)
			return 1;
		else
			return 0;
}

/***************************************/
/* merge 2 lists under dummy head item */
/***************************************/
node* Nlmerge (node* p, node* q) {
	node* r;
	node head;

    for (r = &head; p && q; ) {
		if ( Nsort(p, q) < 0 ) {
			r = r->next = p;
			p = p->next;
		}
		else {
			r = r->next = q;
			q = q->next;
		}
	}
	r->next = (p ? p : q);
	return head.next;
}

/*********************************************************/
/* split list into 2 parts, sort each recursively, merge */
/*********************************************************/
node* Nlsort (node* p) {
	node* q;
	node* r;

    if ( p ) {
        q = p;
        for ( r = q->next; r && (r = r->next) != NULL; r = r->next )
            q = q->next;
        r = q->next;
        q->next = NULL;
        if ( r )
			p = Nlmerge(Nlsort(r), Nlsort(p));
    }
    return p;
}
/***********************/
int Usort(user* this, user* that) {
	if (this->msgk > that->msgk)
		return -1;
	else if (this->msgk < that->msgk)
		return 1;
	else return 0;
}

/***************************************/
/* merge 2 lists under dummy head item */
/***************************************/
user* Ulmerge (user* p, user* q) {
	user* r;
	user head;

    for (r = &head; p && q; ) {
		if ( Usort(p, q) < 0 ) {
			r = r->next = p;
			p = p->next;
		}
		else {
			r = r->next = q;
			q = q->next;
		}
	}
	r->next = (p ? p : q);
	return head.next;
}

/*********************************************************/
/* split list into 2 parts, sort each recursively, merge */
/*********************************************************/
user* Ulsort (user* p) {
	user* q;
	user* r;

    if ( p ) {
        q = p;
        for ( r = q->next; r && (r = r->next) != NULL; r = r->next )
            q = q->next;
        r = q->next;
        q->next = NULL;
        if ( r )
			p = Ulmerge(Ulsort(r), Ulsort(p));
    }
    return p;
}
/****************************/
int Rsort(room* this, room* that) {
	if (this->msgk > that->msgk)
		return -1;
	else if (this->msgk < that->msgk)
		return 1;
	else return 0;
}

/***************************************/
/* merge 2 lists under dummy head item */
/***************************************/
room* Rlmerge (room* p, room* q) {
	room* r;
	room head;

    for (r = &head; p && q; ) {
		if ( Rsort(p, q) < 0 ) {
			r = r->next = p;
			p = p->next;
		}
		else {
			r = r->next = q;
			q = q->next;
		}
	}
	r->next = (p ? p : q);
	return head.next;
}

/*********************************************************/
/* split list into 2 parts, sort each recursively, merge */
/*********************************************************/
room* Rlsort (room* p) {
	room* q;
	room* r;

    if ( p ) {
        q = p;
        for ( r = q->next; r && (r = r->next) != NULL; r = r->next )
            q = q->next;
        r = q->next;
        q->next = NULL;
        if ( r )
			p = Rlmerge(Rlsort(r), Rlsort(p));
    }
    return p;
}

/***********************/
int Gsort(region* this, region* that) {
	if (this->msgk > that->msgk)
		return -1;
	else if (this->msgk < that->msgk)
		return 1;
	else return 0;
}

/***************************************/
/* merge 2 lists under dummy head item */
/***************************************/
region* Glmerge (region* p, region* q) {
	region* r;
	region head;

    for (r = &head; p && q; ) {
		if ( Gsort(p, q) < 0 ) {
			r = r->next = p;
			p = p->next;
		}
		else {
			r = r->next = q;
			q = q->next;
		}
	}
	r->next = (p ? p : q);
	return head.next;
}

/*********************************************************/
/* split list into 2 parts, sort each recursively, merge */
/*********************************************************/
region* Glsort (region* p) {
	region* q;
	region* r;

    if ( p ) {
        q = p;
        for ( r = q->next; r && (r = r->next) != NULL; r = r->next )
            q = q->next;
        r = q->next;
        q->next = NULL;
        if ( r )
			p = Glmerge(Glsort(r), Glsort(p));
	}
	return p;
}

/***********************/
int Ssort(soft* this, soft* that) {
	if (this->msgk > that->msgk)
		return -1;
	else if (this->msgk < that->msgk)
		return 1;
	else return 0;
}

/***************************************/
/* merge 2 lists under dummy head item */
/***************************************/
soft* Slmerge (soft* p, soft* q) {
	soft* r;
	soft head;

    for (r = &head; p && q; ) {
		if ( Ssort(p, q) < 0 ) {
			r = r->next = p;
			p = p->next;
		}
		else {
			r = r->next = q;
			q = q->next;
		}
	}
	r->next = (p ? p : q);
	return head.next;
}

/*********************************************************/
/* split list into 2 parts, sort each recursively, merge */
/*********************************************************/
soft* Slsort (soft* p) {
	soft* q;
	soft* r;

    if ( p ) {
        q = p;
        for ( r = q->next; r && (r = r->next) != NULL; r = r->next )
            q = q->next;
        r = q->next;
        q->next = NULL;
        if ( r )
			p = Slmerge(Slsort(r), Slsort(p));
	}
	return p;
}

/****************************/
int Lsort(link* this, link* that) {
	if (this->msgk > that->msgk)
		return -1;
	else if (this->msgk < that->msgk)
		return 1;
	else return 0;
}

/***************************************/
/* merge 2 lists under dummy head item */
/***************************************/
link* Llmerge (link* p, link* q) {
	link* r;
	link head;

    for (r = &head; p && q; ) {
		if ( Lsort(p, q) < 0 ) {
			r = r->next = p;
			p = p->next;
		}
		else {
			r = r->next = q;
			q = q->next;
		}
	}
	r->next = (p ? p : q);
	return head.next;
}

/*********************************************************/
/* split list into 2 parts, sort each recursively, merge */
/*********************************************************/
link* Llsort (link* p) {
	link* q;
	link* r;

    if ( p ) {
        q = p;
        for ( r = q->next; r && (r = r->next) != NULL; r = r->next )
            q = q->next;
        r = q->next;
        q->next = NULL;
        if ( r )
			p = Llmerge(Llsort(r), Llsort(p));
    }
    return p;
}

/****************************************************************************/
/* outdekay() -- outputs the delay list...                                  */
/****************************************************************************/
void    outdelay(void)
{
label   dlong;
label   dshort;
label   daverage;
label   tempday;
long    totdelay = 0;
long    totstamped = 0;
long    totshort = 0;
long    totlong = 0;
long    tothops = 0;
long    totshops = -1;
long    totlhops = 0;
long    tothopped = 0;

    fprintf(delayout, "%s                                   Delay time                          Hops%s\n", color.head, color.norm);
    fprintf(delayout, "%s                             %s\n", color.line, color.norm);
    fprintf(delayout, "%s%-20.20s %12s %12s %12s %6s %3s %3s %3s%s\n", color.head, "Nodename", "average", "longest", "shortest", "stamps", "ave", "lng", "sht", color.norm);
    fprintf(delayout, "%s       %s\n", color.line, color.norm);

    for(currnode = firstnode; currnode != NULL; currnode = currnode->next)
    {
		if(currnode->stamped)
		{
			if((currnode->longest)/60/60/24)
				sprintf(tempday, "%ldd ", (currnode->longest)/60/60/24);
			else
				tempday[0] = 0;

			sprintf(dlong, "%s%02ld:%02ld:%02ld", tempday,
				(currnode->longest)/60/60 % 24, (currnode->longest)/60 % 60,
				(currnode->longest) % 60);

			tempday[0] = 0;

			if((currnode->shortest)/60/60/24)
				sprintf(tempday, "%ldd ", (currnode->shortest)/60/60/24);
			else
				tempday[0] = 0;

			sprintf(dshort, "%s%02ld:%02ld:%02ld", tempday,
				(currnode->shortest)/60/60 % 24,
				(currnode->shortest)/60 % 60,
				(currnode->shortest) % 60);

			tempday[0] = 0;

			if((currnode->average/currnode->stamped)/60/60/24)
				sprintf(tempday, "%ldd ", (currnode->average/currnode->stamped)/60/60/24);
			else
				tempday[0] = 0;

			sprintf(daverage, "%s%02ld:%02ld:%02ld", tempday,
				(currnode->average/currnode->stamped)/60/60 % 24,
				(currnode->average/currnode->stamped)/60 % 60,
				(currnode->average/currnode->stamped) % 60);

            fprintf(delayout, "%-20.20s%s%s%12s %12s %12s %6ld%s%s%3d %3d %3d\n",
                    strlen(currnode->name) <= 20 ? currnode->name : currnode->address,
                    color.line, color.norm,
                    daverage, dlong, dshort, currnode->stamped,
                    color.line, color.norm,
                    currnode->hopped ? (int)(currnode->avehop/currnode->hopped) : 0,
                    currnode->longhop,
                    currnode->shorthop != -1 ? currnode->shorthop : 0);

			totdelay += currnode->average;
			totstamped += currnode->stamped;

			if(currnode->longest > totlong)
				totlong = currnode->longest;

			if(!totshort)
				totshort = currnode->shortest;
			else
				if(currnode->shortest < totshort)
					totshort = currnode->shortest;
		}

		if(currnode->hopped)
		{
			tothopped += currnode->hopped;
			tothops += currnode->avehop;

			if(currnode->longhop && currnode->longhop > totlhops)
				totlhops = currnode->longhop;

			if(currnode->shorthop != -1)
			{
				if(totshops != -1)
					totshops = currnode->shorthop;
				else
					if(currnode->shorthop && currnode->shorthop < totshops)
						totshops = currnode->shorthop;
			}
		}
	}		// end of main loop thingy.

	// Global stuff from here on.
	if((totlong)/60/60/24)
		sprintf(tempday, "%ldd ", (totlong)/60/60/24);
	else
		tempday[0] = 0;

	sprintf(dlong, "%s%02ld:%02ld:%02ld", tempday,
		(totlong)/60/60 % 24,
		(totlong)/60 % 60,
		(totlong) % 60);

	if((totshort)/60/60/24)
		sprintf(tempday, "%ldd ", (totshort)/60/60/24);
	else
		tempday[0] = 0;

	sprintf(dshort, "%s%02ld:%02ld:%02ld", tempday,
		(totshort)/60/60 % 24,
		(totshort)/60 % 60,
		(totshort) % 60);

	if((totdelay/totstamped)/60/60/24)
		sprintf(tempday, "%ldd ", (totdelay/totstamped)/60/60/24);
	else
		tempday[0] = 0;

	sprintf(daverage, "%s%02ld:%02ld:%02ld", tempday,
		(totdelay/totstamped)/60/60 % 24,
		(totdelay/totstamped)/60 % 60,
		(totdelay/totstamped) % 60);

	fprintf(delayout, "%-20.20s %s      %s\n", "", color.line, color.norm);
	fprintf(delayout, "%s%-20.20s%s%s%s%12s %12s %12s %6ld%s%s%3d %3d %3d\n",
							  color.head, "Global averages:", color.norm,
							  color.line, color.norm,
							  daverage, dlong, dshort, totstamped,
							  color.line, color.norm,
							  tothopped ? (tothops/tothopped) : 0,
							  totlhops, totshops);
}

/****************************************************************************/
/* output() -- pretty obvious...                                            */
/****************************************************************************/
void    output(void)
{
int     i, msgindex, graph, isize;
label   tmp;

	printf("Writing: ");
    printf("Nodes...");
	fprintf(nodesout, "%sNodename                    address   soft  msgs  msgb  AVb/msg %% msgs %% msgb%s\n", color.head, color.norm);
	fprintf(nodesout, "%s       %s\n", color.line, color.norm);

	for(currnode = firstnode, i = 0; currnode != NULL; currnode = currnode->next, i++)
    {
        if(criteria(currnode->msgk, typenode, i))
        {
            int l;

            for(currsoft = firstsoft; currsoft->hash != currnode->softhash; currsoft = currsoft->next)
                 ;

            for(l=0; software[l] != NULL; l++)
                if(strstr(currsoft->name, software[l]) != 0)
                    break;

            fprintf(nodesout, "%-25.25s (%8.8s) %5s %5ld %6ld %4lu.%02lu %2lu.%02lu%% %2lu.%02lu%%\n",
                              currnode->name,
                              currnode->address,
                              softkey[l] ? softkey[l] : "??",
                              currnode->messages,
                              currnode->msgk,
                              (unsigned long)(((unsigned long)currnode->msgk*100)/(unsigned long)currnode->messages) / 100,
                              (unsigned long)(((unsigned long)currnode->msgk*100)/(unsigned long)currnode->messages) % 100,
                              (unsigned long)(((unsigned long)currnode->messages*10000/(unsigned long)nmessages)) / 100,
                              (unsigned long)(((unsigned long)currnode->messages*10000/(unsigned long)nmessages)) % 100,
                              (unsigned long)(((unsigned long)currnode->msgk*10000/(unsigned long)messagek)) / 100,
                              (unsigned long)(((unsigned long)currnode->msgk*10000/(unsigned long)messagek)) % 100);
        }
    }

	fprintf(nodesout, "\n%s\tTotal of %d nodes\n", color.tail, numnode);
	fprintf(nodesout, "\t%ld local-only messages totaling %ld bytes.\n", local, localmsgk);
	fprintf(nodesout, "\tList generated from %ld net messages totaling %ld bytes.\n"
					  "\t%ld msg.dat.%s\n",
			nmessages, messagek, mdatlength, color.norm);

	fclose(nodesout);

	printf("Rooms...");
	fprintf(roomsout, "%sRoomname                        msgs  msgb  AVb/msg %% msgs %% msgb%s\n", color.head, color.norm);
	fprintf(roomsout, "%s     %s\n", color.line, color.norm);

	for(currroom = firstroom, i = 0; currroom != NULL; currroom = currroom->next, i++)
        if(criteria(currroom->msgk, typeroom, i))
            fprintf(roomsout, "%-30.30s %5ld %6ld %4lu.%02lu %2lu.%02lu%% %2lu.%02lu%%\n",
                              currroom->roomname,
                              currroom->messages,
                              currroom->msgk,
                              (unsigned long)(((unsigned long)currroom->msgk*100)/(unsigned long)currroom->messages) / 100,
                              (unsigned long)(((unsigned long)currroom->msgk*100)/(unsigned long)currroom->messages) % 100,
                              (unsigned long)(((unsigned long)currroom->messages*10000/(unsigned long)nmessages)) / 100,
                              (unsigned long)(((unsigned long)currroom->messages*10000/(unsigned long)nmessages)) % 100,
                              (unsigned long)(((unsigned long)currroom->msgk*10000/(unsigned long)messagek)) / 100,
                              (unsigned long)(((unsigned long)currroom->msgk*10000/(unsigned long)messagek)) % 100);

	fprintf(roomsout, "\n%s\tTotal of %d rooms\n", color.tail, numroom);
	fprintf(roomsout, "\tList generated from %ld messages totaling %ld bytes.\n"
					  "\t%ld msg.dat.%s\n",
			nmessages, messagek, mdatlength, color.norm);

	fclose(roomsout);

	printf("Users...");
	fprintf(usersout, "%s     Username                        msgs  msgb  AVb/msg %% msgs %% msgb%s\n", color.head, color.norm);
	fprintf(usersout, "%s          %s\n", color.line, color.norm);

	for(i = 0, curruser = firstuser; curruser != NULL;curruser = curruser->next, i++)
		if(curruser->username[0] && criteria(curruser->msgk, typeuser, i))
			fprintf(usersout, "%3d. %-30.30s %5ld %6lu %4lu.%02lu %2lu.%02lu%% %2lu.%02lu%%\n",
					i+1,
					curruser->username,
					curruser->messages,
					curruser->msgk,
                    (unsigned long)(((unsigned long)curruser->msgk*100)/(unsigned long)curruser->messages) / 100,
                    (unsigned long)(((unsigned long)curruser->msgk*100)/(unsigned long)curruser->messages) % 100,
                    (unsigned long)(((unsigned long)curruser->messages*10000/(unsigned long)nmessages)) / 100,
                    (unsigned long)(((unsigned long)curruser->messages*10000/(unsigned long)nmessages)) % 100,
                    (unsigned long)(((unsigned long)curruser->msgk*10000/(unsigned long)messagek)) / 100,
                    (unsigned long)(((unsigned long)curruser->msgk*10000/(unsigned long)messagek)) % 100);

	fprintf(usersout, "\n%s\tTotal of %d users\n", color.tail, numuser);
	fprintf(usersout, "\tList generated from %ld messages totaling %ld bytes.\n"
					  "\t%ld msg.dat.%s\n",
                      nmessages, messagek, mdatlength, color.norm);

	fclose(usersout);

	printf("Regions...");
	fprintf(regionout, "%sRegion  msgs    msgb AVb/msg %% msgs %% msgb%s\n", color.head, color.norm);
	fprintf(regionout, "%s     %s\n", color.line, color.norm);

	for(i=0, currregion = firstregion; currregion != NULL;currregion = currregion->next, i++)
        if(criteria(currregion->msgk, typeregion, i))
			fprintf(regionout, "%-6.6s %5ld %7lu %4lu.%02lu %2lu.%02lu%% %2lu.%02lu%%\n",
					currregion->name,
					currregion->messages,
					currregion->msgk,
                    (unsigned long)(((unsigned long)currregion->msgk*100)/(unsigned long)currregion->messages) / 100,
                    (unsigned long)(((unsigned long)currregion->msgk*100)/(unsigned long)currregion->messages) % 100,
                    (unsigned long)(((unsigned long)currregion->messages*10000/(unsigned long)nmessages)) / 100,
                    (unsigned long)(((unsigned long)currregion->messages*10000/(unsigned long)nmessages)) % 100,
                    (unsigned long)(((unsigned long)currregion->msgk*10000/(unsigned long)messagek)) / 100,
                    (unsigned long)(((unsigned long)currregion->msgk*10000/(unsigned long)messagek)) % 100);

	fprintf(regionout, "\n%s\tTotal of %d regions.\n", color.tail, numregion);
	fprintf(regionout, "\tList generated from %ld messages totaling %ld bytes.\n"
					  "\t%ld msg.dat.%s\n",
			nmessages, messagek, mdatlength, color.norm);

	fclose(regionout);

	printf("Extended nodes...");
	for(currnode = firstnode, i = 0; currnode != NULL; currnode = currnode->next, i++)
    {
        if(criteria(currnode->msgk, typenode, i))
        {
            for(currsoft = firstsoft; currsoft->hash != currnode->softhash; currsoft = currsoft->next)
                ;

            fprintf(nodes2out, " %s%s,%s %s%s,%s %s%s,%s %s %s[%s%s%s]%s\n"
                               " %s%s,%s %s\n"
                               "\n",
                               currnode->name, color.comma, color.norm,
                               currnode->region, color.comma, color.norm,
                               currnode->state, color.comma, color.norm,
                               currnode->country, color.comma, color.norm,
                               currnode->address, color.comma, color.norm,
                               currsoft->name, color.comma, color.norm,
                               currnode->phone);
        }
    }

	fclose(nodes2out);

	printf("Delays...");
	outdelay();

	fclose(delayout);

	printf("Links...");
		fprintf(linkslst, "%sLink                  msgs   msgb   AVb/msg %% msgs %% msgb%s\n", color.head, color.norm);
	fprintf(linkslst, "%s     %s\n", color.line, color.norm);
		for(currlink = firstlink, i = 0; currlink != NULL; currlink = currlink->next, i++)
		{
            if(criteria(currlink->msgk, typelink, i))
            {
                sprintf(tmp, "%-8s<->%8s", currlink->add1, currlink->add2);
                fprintf(linkslst, "%-20.20s %6lu %7lu %4lu.%02lu %2lu.%02lu%% %2lu.%02lu%%\n",
                        tmp,
                        currlink->messages,
                        currlink->msgk,
                        (unsigned long)(((unsigned long)currlink->msgk*100)/(unsigned long)currlink->messages) / 100,
                        (unsigned long)(((unsigned long)currlink->msgk*100)/(unsigned long)currlink->messages) % 100,
                        (unsigned long)(((unsigned long)currlink->messages*10000/(unsigned long)nmessages)) / 100,
                        (unsigned long)(((unsigned long)currlink->messages*10000/(unsigned long)nmessages)) % 100,
                        (unsigned long)((unsigned long)(((unsigned long)currlink->msgk * 100L) / (unsigned long)messagek) * 100L) / 100L,
                        (unsigned long)((unsigned long)(((unsigned long)currlink->msgk * 10000L) / (unsigned long)messagek)) % 100L);
            }
		}

		fprintf(linkslst, "\n%s\tTotal of %d network links.\n"
						  "\tList generated from %ld messages totaling %ld bytes.\n"
						  "\t%ld msg.dat.%s\n",
						  color.tail, numlink,
						  nmessages, messagek, mdatlength, color.norm);

	fclose(linkslst);

    // We're now at the end of an 80 column screen...so lets move down a line
    // and line "software" up with the "Writing:" statement...
	printf("\n         Software...");
	fprintf(softout, "%sSoftware                       msgs     msgb AVb/msg %% msgs %% msgb boards %%brds%s\n", color.head, color.norm);
	fprintf(softout, "%s       %s\n", color.line, color.norm);

	for(currsoft = firstsoft, i = 0; currsoft != NULL; currsoft = currsoft->next, i++)
    {
int use = 0;

        if(criteria(currsoft->msgk, typesoft, i))
        {
            for(currnode = firstnode; currnode != NULL; currnode = currnode->next)
                if(currnode->softhash == currsoft->hash)
                    use++;

            fprintf(softout, "%-29.29s %6ld %7ld %4lu.%02lu %2lu.%02lu%% %2lu.%02lu%% %5d %2lu.%02lu%%\n",
                    currsoft->name[0] ? currsoft->name : "[Other]",
                    currsoft->messages,
                    currsoft->msgk,
                    (unsigned long)(((unsigned long)currsoft->msgk*100)/(unsigned long)currsoft->messages) / 100,
                    (unsigned long)(((unsigned long)currsoft->msgk*100)/(unsigned long)currsoft->messages) % 100,
                    (unsigned long)(((unsigned long)currsoft->messages*10000/(unsigned long)nmessages)) / 100,
                    (unsigned long)(((unsigned long)currsoft->messages*10000/(unsigned long)nmessages)) % 100,
                    (unsigned long)(((currsoft->msgk * 100) / messagek) * 100) / 100,
                    (unsigned long)(((currsoft->msgk * 10000) / messagek)) % 100,
                    use,
                    (unsigned long)(((unsigned long)use*10000/(unsigned long)numnode)) / 100,
                    (unsigned long)(((unsigned long)use*10000/(unsigned long)numnode)) % 100);
        }
    }

	fprintf(softout, "\n%s\tTotal of %d software types\n", color.tail, numsoft);
	fprintf(softout, "\tList generated from %ld messages totaling %ld bytes.\n"
					  "\t%ld msg.dat.%s\n",
			nmessages, messagek, mdatlength, color.norm);

	fclose(softout);

    printf("Size Graph...");

    if(scale == -1)
    {
int tempmsgs = 0;

        for(msgindex = 0; msgindex < totalsteps; msgindex++)
            if(tempmsgs < msg_size[msgindex])
                tempmsgs = msg_size[msgindex];

        scale = tempmsgs / 71;

        printf("scale: %d", scale);
    }

    for(msgindex = 0, isize = 0; msgindex < totalsteps; msgindex++, isize += stepsize)
    {
        fprintf(sizeout, "%4.4d%s%s ", isize, color.line, color.norm);
        if(graphtype == BAR)
            for(graph = 0; graph < (((long)msg_size[msgindex] * 10000) / nmessages * scale / 10000); graph++)
            {
                fputc(graphchar, sizeout);
                if(graph >= 71)
                    break;
            }
        else
            if(graphtype == SCATTER)
            {
                for(graph = 0; graph < ((((long)msg_size[msgindex] * 10000) / nmessages * scale + 1) / 10000); graph++)
                {
                    fputc(' ', sizeout);
                    if(graph >= 71)
                        break;
                }
                fputc(graphchar, sizeout);
            }
        fputc('\n', sizeout);
    }

    fclose(sizeout);
    printf("\n");
}

/****************************************************************************/
/* criteria() returns not FALSE if the item should be listed.               */
/****************************************************************************/
int   criteria(long msgk, int listtype, int i)
{
        if (listtype > 0) {
            return(((long)msgk*10000)/(long)messagek >= (long)listtype);
        } else if (listtype < 0) {
            return((-listtype) > i);
        } else {
            return(TRUE);
        }
}

/* from snippets 95/10
   public domain by david engel.
   slightly modified by GS.
*/
FILE *pfopen(const char* name, const char* mode, const char* dirs)
{
    char* ptr;
    char* tdirs;
    FILE* file = NULL;

    if (dirs == NULL || dirs[0] == '\0')
        return NULL;

    if ((tdirs = malloc(strlen(dirs)+1)) == NULL)
        return NULL;

    strcpy(tdirs, dirs);

    for (ptr = strtok(tdirs, ";"); file == NULL && ptr != NULL;
        ptr = strtok(NULL, ";"))
    {
        size_t len;
        char work[FILENAME_MAX];

        strcpy(work, ptr);
        len = strlen(work);
        if (len && work[len-1] != '\\')
            strcat(work, "\\");
        strcat(work, name);

        file = fopen(work, mode);
    }

    free(tdirs);

    return file;
}

/* ------------------------------------------------------------------- */
/* config()  --  Reads a config file.                                  */
/* Lifted by GS from Audin's poster 1.6 source. Not the best config    */
/*  file routines, but they'll work for now!                           */
/* ------------------------------------------------------------------- */
void config(char softname[257])
{
    int i;
    FILE *cfg;
	char *text, *ptr1;

    /* we're not in a multitasker, so save stack by making them static */
	static char line[257], word1[257], lword1[257];
	static char drive[5], dir[257], dirlist[257];

    static char funny[] = "You have a funny #%s setting.  I will use the default.\n";

    static char *KEYWORD[] = {
        "msgfile",                  /* 0 - msg.dat file */
		"nodelist",					/* 1 - output file */
		"sizelist",                 /* 2 - */
		"",                         /* 3 - */
		"output",                   /* 4 - output type */
		"userlist", 				// 5 - userlist out
		"roomlist",					// 6 - roomlist
		"nodelist2",                // 7 - extended nodelist
		"nodename",                 // 8 - Host nodename
		"address",                  // 9 - Host address
		"software",                 // 10 - host software
		"region",                   // 11 - host region
		"state",                    // 12 - host state
		"country",                  // 13 - host country
		"phone",                    // 14 - host phone
		"jaydee",					// 15 - exclude jaydee nodes?
		"debug",					// 16 - debug mode?
		"linklist",					// 17 - linklist out.
		"color_norm",				// 18
		"color_bright",				// 19
		"color_head",				// 20
		"color_tail",				// 21
		"color_comma",				// 22
		"color_line",				// 23
		"delaylist",				// 24 delay list out filename.
		"regionlist",				// 25 region list out file.
        "fuelbar",					// 26 sets the fuelbar chars...
        "overwrite",                // 27 write over existing files?
        "softlist",                 // 28 where to stick the software list.
        "graphtype",                // 29 BAR or SCATTER.
        "stepsize",                 // 30 msg size step size.
        "graphchar",                // 31
        "excl_node",                // 32
        "excl_user",                // 33
        "excl_room",                // 34
        "excl_region",              // 35
        "excl_software",            // 36
        "lower_end",                // 37
        "upper_end",                // 38
        "scale",                    // 39
        "type_node",                // 40 sets nodetype
        "type_user",                // 41 sets usertype
        "type_room",                // 42 sets roomtype
        "type_soft",                // 43 sets softtype
        "type_region",              // 44 sets regiontype
        "type_link",                // 45 sets linktype
		NULL
    };

    drive[0] = dir[0] = dirlist[0] = 0;

    /* search these areas for the configuration file:
        current directory
        executable directory
        path
    */
	fnsplit(softname, drive, dir, NULL, NULL);
    sprintf(dirlist, ".;%s%s;%s", drive, dir, getenv("PATH"));
	cfg = pfopen("nodes.cfg", "rt", dirlist);
    if (cfg == NULL) {
        printf("No config file present.\n");
        exit(1);
    }

	printf("Reading configuration file: nodes.cfg\n\n");

    while (!feof(cfg)) {
        text = fgets(line, sizeof(line), cfg);
        if(text == 0)
            break;
        if(line[0] != '#')
            continue;

        i = sscanf(line, "%s \"%255[^\"\n\r\t]", word1, lword1);

        if (i == 1)
            i = sscanf(line, "%s %255s", word1, lword1);
        if (i != 2)
            continue;

        for (i = 0; KEYWORD[i] != NULL; i++)
            if (stricmp(&word1[1], KEYWORD[i]) == 0)
                break;

        switch (i) {
            case 0:                     /* #msgfile */
                strcpy(inputmail, lword1);
				break;

            case 1:                     /* #outfile */
				strcpy(outputnode, lword1);
				break;

            case 2:                     // sizelist.
                 strcpy(outsizelist, lword1);
                 break;

            case 3:                     /* #exclude */
				break;

            case 4:                 // output.  (status type)
				status = atoi(lword1);
				break;

			case 5:					// userlist out
				strcpy(outputuser, lword1);
				break;

			case 6:					// roomlist out
				strcpy(outputroom, lword1);
				break;

			case 7:					// extended node out
				strcpy(outnodelist, lword1);
				break;

			case 8:					// nodename
				lword1[30] = 0;
				strcpy(homenode, lword1);
				break;

			case 9:					// address
				lword1[30] = 0;
				strcpy(homeadd, "!");
				strcat(homeadd, lword1);

				if((ptr1 = strchr(lword1, '.')) != NULL)
				{
					*ptr1 = 0;
					strcpy(homealias, lword1);
				}
				else
				{
					printf("You have a broken #address entry.  Fix it, it's important.\n");
					exit(1);
				}
				break;

			case 10:				// software
				lword1[30] = 0;
				strcpy(homesoft, lword1);
				break;

			case 11:				// region
				lword1[30] = 0;
				strcpy(homeregion, lword1);
				break;

			case 12:				// state
				lword1[30] = 0;
				strcpy(homestate, lword1);
				break;

			case 13:				// country
				lword1[30] = 0;
				strcpy(homecountry, lword1);
				break;

			case 14:				// phone
				lword1[30] = 0;
				strcpy(homephone, lword1);
				break;

			case 15:					// jaydee
				break;

			case 16:
				if(lword1[0] == '1')
					debug = 1;
				break;

			case 17:					// linklist out
				strcpy(outlinklist, lword1);
				break;

			case 18:
				lword1[30] = 0;
				expand(lword1);
				strcpy(color.norm, lword1);
				break;

			case 19:
				lword1[30] = 0;
				expand(lword1);
				strcpy(color.bright, lword1);
				break;

			case 20:
				lword1[30] = 0;
				expand(lword1);
				strcpy(color.head, lword1);
				break;

			case 21:
				lword1[30] = 0;
				expand(lword1);
				strcpy(color.tail, lword1);
				break;

			case 22:
				lword1[30] = 0;
				expand(lword1);
				strcpy(color.comma, lword1);
				break;

			case 23:
				lword1[30] = 0;
				expand(lword1);
				strcpy(color.line, lword1);
				break;

			case 24:		// delaylist
				strcpy(outputdelay, lword1);
				break;

			case 25:		// region list
				strcpy(outputregion, lword1);
				break;

            case 26:		// fuelbar.
            	if(strlen(lword1) > 2)
                {
                	printf(funny, "fuelbar");
                    break;
                }
                else
                {
					fuelempty = lword1[0];
					fuelfull  = lword1[1];
                }
                break;

            case 27:        // Overwrite
				if(lword1[0] == '1')
					overwrite = 1;
				break;

            case 28:        // Soft list.
				strcpy(outputsoft, lword1);
				break;

            case 29:        // graph type.
                if(stricmp(lword1, "BAR") == 0)
                    graphtype = BAR;
                else
                    if(stricmp(lword1, "SCATTER") == 0)
                        graphtype = SCATTER;
                    else
                        printf(funny, "graphtype");
                break;

            case 30:        // graph step size.
                 if((stepsize = atoi(lword1)) == 0)
                 {
                     printf(funny, "stepsize");
                     stepsize = 200;
                 }
                 break;

            case 31:        // graph char.
                 if(strlen(lword1) > 2)
                     printf(funny, "graphchar");
                 else
                     graphchar = lword1[0];
                 break;

            case 32:        // exclude node.
                 AddExcl(XNODE, lword1);
                 break;

            case 33:
                 AddExcl(XUSER, lword1);
                 break;

            case 34:
                 AddExcl(XROOM, lword1);
                 break;

            case 35:
                 AddExcl(XREGION, lword1);
                 break;

            case 36:
                 AddExcl(XSOFT, lword1);
                 break;

            case 37:        // lower_end
                 if((lower_end = atoi(lword1)) <= 0)
                 {
                     printf(funny, "lower_end");
                     lower_end = 0;
                 }
                 break;

            case 38:        // upper_end
                 if((upper_end = atoi(lword1)) == 0)
                 {
                     printf(funny, "upper_end");
                     upper_end = 8192;
                 }
                 else
                     if(upper_end > 8192)
                     {
                         printf("Well, as far as I know, citadel messages can't be more than 8K, however, I\n"
                                "will set the higher end of the size graph to %d anyway.\n", upper_end);
                     }
                 break;

            case 39:        // scale
                 if((scale = atoi(lword1)) == 0 || scale < -1)
                 {
                     printf(funny, "scale");
                     scale = 1000;
                 }
                 break;

            case 40:        // nodetype
                 typenode = atoi(lword1);
                 break;

            case 41:        // usertype
                 typeuser = atoi(lword1);
                 break;

            case 42:        // roomtype
                 typeroom = atoi(lword1);
                 break;

            case 43:        // softtype
                 typesoft = atoi(lword1);
                 break;

            case 44:        // regiontype
                 typeregion = atoi(lword1);
                 break;

            case 45:        // linktype
                 typelink = atoi(lword1);
                 break;

            default:
                printf("Keyword '%s' unknown.\n", word1);
                exit(1);
                break;
        }
    }
    fclose(cfg);
}

/***************************************************************************/
/* expand() - handles ^A's.                                                */
/***************************************************************************/
void	expand(char *str)
{
	int i = 0;
	char *pc;

	pc = str;

	while (*pc)
	{
		if (*pc == '^')
		{
			if (*(pc + 1))
			{
				if (toupper(*(pc + 1)) == 'A')
				{
					str[i] = 0x01;
					i++;
					pc += 2;
				}
			}
		}
		else
		{
			str[i] = *pc;
			i++;
			pc++;
		}
	}
	str[i] = 0;
}

/* -------------------------------------------------------------------- */
/*  startup...  opens all files.                                        */
/* -------------------------------------------------------------------- */
void startup(void)
{
int i;

    ctrlbrk(cbreak);

    // Open the message base.
	if((msgdat = fopen(inputmail, "rb")) == NULL) {
		printf(" I can't seem to find \"%s\".\n", inputmail);
		exit(1);
	}

    setvbuf(msgdat, NULL, _IOFBF, 4096);    // Buffer it.

    mdatlength = filelength(fileno(msgdat));

    if(status != 3)
        setvbuf(stdout, NULL, _IOFBF, 8);   // So I have a slow video card... :-)
    // buffer this, too...but only if we're not using the bar graph display.

    // open the various output files.
    nodesout  = openoutfile(outputnode);
    roomsout  = openoutfile(outputroom);
    usersout  = openoutfile(outputuser);
    softout   = openoutfile(outputsoft);
    nodes2out = openoutfile(outnodelist);
    linkslst  = openoutfile(outlinklist);
    delayout  = openoutfile(outputdelay);
    regionout = openoutfile(outputregion);
    sizeout   = openoutfile(outsizelist);

    totalsteps = (upper_end - lower_end) / stepsize;

    if((msg_size = (int *)calloc(totalsteps + 2, sizeof(int))) == NULL)
    {
        printf("Can't allocate space for message size array.\n");
        exit(1);
    }

    for(i = 0; i < totalsteps - 1; i++)
        msg_size[i] = 0;

	printf("Input filename..: %-20s  Size (Bytes)....: %ld\n", inputmail, mdatlength);
	printf("Node stat output: %-20s  Home nodename...: %s\n"
		   "Room stat output: %-20s  Home address....: %s\n"
		   "Nodes2 outout...: %-20s  Home region.....: %s\n"
		   "User stat output: %-20s  Home country....: %s\n"
		   "Link list output: %-20s  Home state......: %s\n"
		   "Net delay output: %-20s  Home phone......: %s\n"
           "Regions stat out: %-20s  Home software...: %s\n"
           "Software output.: %-20s  Debug mode......: %s\n"
		   "Status type.....: %-20d  Exclusions......: %s (%d)\n"
           "Overwrite mode..: %-20s  Graph Parameters: %d to %d bytes\n"
           "Graph type......: %-20s  Total steps: %4.4d Scale: %d\n"
           "Size graph out..: %-20s  Stepsize........: %d\n"
		   "\n",
		outputnode,  homenode,
		outputroom,  homeadd+1,
		outnodelist, homeregion,
		outputuser,  homecountry,
		outlinklist, homestate,
		outputdelay, homephone,
        outputregion,homesoft,
        outputsoft,  (debug) ? "On" : "Off",
		status,      (exclusions) ? "Yes" : "No", exclusions,
        (overwrite) ? "On" : "Off",
        lower_end, upper_end,
        (graphtype) ? "Scatter" : "Bar", totalsteps, scale,
        outsizelist, stepsize);

	if(!status)
		printf("New Node:   New Room:   New User:   New Link: !  New Region: r\n"
			   "    Mail: M      Copy: C     Local: L   cLength: *\n\n");

    if(status == 3)
        o_reset(fuelempty, fuelfull, 79, mdatlength);
}

/*************************************************************************/
/* headers() -- outputs headers...                                       */
/*************************************************************************/
void headers(void)
{
    // normal nodelist headers.
	fprintf(nodesout, "\t%sList of current active citnet nodes and addresses.%s\n"
					  "\n"
					  "This list is created automaticly by scanning the %s message\n"
					  "base for node names.  Thus it is possable for new or quiet nodes to be missed.\n"
					  "\n", color.head, color.norm, homenode);

	fprintf(nodesout, "%% msgs is the percentage of total messages that come from the node.\n"
					  "Msgb is the total ammount of message text to come from the node, in bytes.\n"
					  "AVb/msg is the average message size from the node, in bytes.\n"
					  "%% msgb is the percentage of total message text that comes from the node.\n"
					  "\n");

   // roomlist.
   fprintf(roomsout, "\t%sList of currently active Citnet rooms.%s\n"
					 "\n"
					 "%% msgs is the percentage of total messages that are in that room.\n"
					 "Msgb is the total ammount of message text in the room, in bytes.\n"
					 "AVb/msg is the room's average message size, also in bytes.\n"
					 "%% msgb is the percentage of total network message text in that room.\n"
					 "\n", color.head, color.norm);

	// userlist.
	fprintf(usersout, "\t%sList of currently active Citnet users.%s\n"
					  "\n"
					  "%%msgs is based on the number user messages / total citnet msgs.\n"
					  "%%msgb is based on the total bytes put out by the user / citnet bytes.\n"
					  "\n", color.head, color.norm);

    // softout.
    fprintf(softout, "\t%sList of software currently active on the Citnet.%s\n"
                     "\n", color.head, color.norm);

    // nodes2out.
	fprintf(nodes2out, "\t%sList of current Citnet nodes.%s\n"
					  "\n"
					  "Complete with phone numbers and other useful bits...\n"
					  "\n"
					  "Nodename%s,%s Region%s,%s County%s,%s Country %s[%saddress%s]%s\n"
					  "Software%s,%s Phone number.\n"
					  "\n"
					  "\n", color.head, color.norm, color.comma, color.norm,
                      color.comma, color.norm, color.comma, color.norm,
                      color.comma, color.norm, color.comma, color.norm,
                      color.comma, color.norm);

    // linklist.
	fprintf(linkslst, "\t%sThe Late Show Link List.%s\n"
					  "\n"
					  "This is how the network looks from %s's viewpoint.\n"
					  "\n", color.head, color.norm, homenode);

    // sizeout.
    fprintf(sizeout, "\t%sHistogram of CitNet message sizes.%s\n\n", color.head, color.norm);
}

/***************************************************************************/
/* openoutfile()  -- Opens an output file.  Checking that it doesn't write */
/*                   over anything in the process.                         */
/***************************************************************************/
FILE	*openoutfile(char* name)
{
FILE *file = NULL;

    if((file = fopen(name, "rb")) != NULL)
    {
        if(!overwrite)
        {
            printf(" I need to be able to write to \"%s\".\n"
                   " However, it seems to already exist."
                   " You should probably delete it.\n", name);
            exit(1);
        }
        else
            printf("I will be writing over \"%s\".\n", name);
    }
    fclose(file);

    if((file = fopen(name, "wt")) == NULL) {
        printf(" I can't seem to open \"%s\" for output.\n", name);
        exit(1);
    }
    else
        if(debug)
            printf("Opened: %s\n", name);

	return(file);
}

/****************************************************************************/
/* Omanager/Sliding Prompt Technology stuff.                                */
/* Thanks to Golden Spud.                                                   */
/****************************************************************************/
void o_update(long rl)
{
long diffcur;
long i;

    long osc = screencur;
    if (rl > realcur)
        realcur = rl;
    else
        return;

    screencur = (realcur * screenlen) / reallen;
    diffcur = screencur - osc;
    for (i = 0; i < diffcur; i++) {
        fputc(fill_ch, stdout);
    }
}
/******/
void o_reset(char s, char f, long sl, long rl)
{
long i;

    start_ch = s;
    fill_ch = f;
    screenlen = sl;
    screencur = 0;
    reallen = rl;
    realcur = 0;

    for (i = 0; i < screenlen; i++)
        fputc(start_ch, stdout);
    for (i = 0; i < screenlen; i++)
        fputc('\b', stdout);
}

/**************************************************************************/
/* Sort()                                                                 */
/**************************************************************************/
void sort(void)
{
	printf("\nSorting: ");

    printf("Nodes...");
	firstnode = Nlsort(firstnode);
	printf("Rooms...");
	firstroom = Rlsort(firstroom);
	printf("Users...");
	firstuser = Ulsort(firstuser);
	printf("Regions...");
	firstregion = Glsort(firstregion);
	printf("Links...");
	firstlink = Llsort(firstlink);
    printf("Software...");
    firstsoft = Slsort(firstsoft);

	printf("\n");
}

/****************************************************************************/
/* AddExcl()                                                                */
/****************************************************************************/
void AddExcl(int type, char *string)
{
xclude* newexcl = NULL;

    exclusions++;

    switch(type)
    {
    case XNODE:
        if(currxnode == NULL) {
            /* no current nodes. */
            firstxnode = currxnode = (xclude *)farmalloc(sizeof(xclude));
			currxnode->next = NULL;
		}
		else {
			/* list has at least one entry. */
			newexcl = (xclude *)farmalloc(sizeof(xclude));
			newexcl->next = NULL;
			currxnode->next = newexcl;
			currxnode = newexcl;
		}
        currxnode->hash = hash(string);

        if(debug)
            printf("Excluding node: %s\n", string);
        break;

    case XUSER:
        if(currxuser == NULL) {
            /* no current nodes. */
            firstxuser = currxuser = (xclude *)farmalloc(sizeof(xclude));
			currxuser->next = NULL;
		}
		else {
			/* list has at least one entry. */
			newexcl = (xclude *)farmalloc(sizeof(xclude));
			newexcl->next = NULL;
			currxuser->next = newexcl;
			currxuser = newexcl;
		}
        currxuser->hash = hash(string);

        if(debug)
            printf("Excluding user: %s\n", string);
        break;

    case XROOM:
        if(currxroom == NULL) {
            /* no current nodes. */
            firstxroom = currxroom = (xclude *)farmalloc(sizeof(xclude));
			currxroom->next = NULL;
		}
		else {
			/* list has at least one entry. */
			newexcl = (xclude *)farmalloc(sizeof(xclude));
			newexcl->next = NULL;
			currxroom->next = newexcl;
			currxroom = newexcl;
		}
        currxroom->hash = hash(string);

        if(debug)
            printf("Excluding room: %s\n", string);
        break;

    case XREGION:
        if(currxregion == NULL) {
            /* no current nodes. */
            firstxregion = currxregion = (xclude *)farmalloc(sizeof(xclude));
			currxregion->next = NULL;
		}
		else {
			/* list has at least one entry. */
			newexcl = (xclude *)farmalloc(sizeof(xclude));
			newexcl->next = NULL;
			currxregion->next = newexcl;
			currxregion = newexcl;
		}
        currxregion->hash = hash(string);

        if(debug)
            printf("Excluding region: %s\n", string);
        break;

    case XSOFT:
        if(currxsoft == NULL) {
            /* no current nodes. */
            firstxsoft = currxsoft = (xclude *)farmalloc(sizeof(xclude));
			currxsoft->next = NULL;
		}
		else {
			/* list has at least one entry. */
			newexcl = (xclude *)farmalloc(sizeof(xclude));
			newexcl->next = NULL;
			currxsoft->next = newexcl;
			currxsoft = newexcl;
		}
        currxsoft->hash = hash(string);

        if(debug)
            printf("Excluding soft: %s\n", string);
        break;

    default:
        printf("Problem with AddExcl().\n");
        break;
    }
}

/****************************************************************************/
/* exclude() - returns TRUE if message is to be excluded.                   */
/****************************************************************************/
int exclude(void)
{
    if(firstxnode)
    {
        for(currxnode = firstxnode; currxnode != NULL; currxnode = currxnode->next)
              if(msgbuf.nodehash == currxnode->hash)
                   return(TRUE);
    }

    if(firstxuser)
    {
        for(currxuser = firstxuser; currxuser != NULL; currxuser = currxuser->next)
              if(msgbuf.authorhash == currxuser->hash)
                   return(TRUE);
    }

    if(firstxroom)
    {
        for(currxroom = firstxroom; currxroom != NULL; currxroom = currxroom->next)
              if(msgbuf.roomhash == currxroom->hash)
                   return(TRUE);
    }

    if(firstxregion)
    {
        for(currxregion = firstxregion; currxregion != NULL; currxregion = currxregion->next)
              if(msgbuf.airhash == currxregion->hash)
                   return(TRUE);
    }

    if(firstxsoft)
    {
        for(currxsoft = firstxsoft; currxsoft != NULL; currxsoft = currxsoft->next)
              if(msgbuf.softhash == currxsoft->hash)
                   return(TRUE);
    }

    return(FALSE);
}

/**************/
int cbreak(void)
{
    printf("\nCtrl-Break hit.\n");
    return(0);
}